## edk2 2025.02

=== BaseTools/Source/C/EfiRom/Makefile ===
## @file
# Windows makefile for 'EfiRom' module build.
#
# Copyright (c) 2007 - 2010, Intel Corporation. All rights reserved.<BR>
# SPDX-License-Identifier: BSD-2-Clause-Patent
#
!INCLUDE ..\Makefiles\ms.common

APPNAME = EfiRom

LIBS = $(LIB_PATH)\Common.lib

OBJECTS = EfiRom.obj

!INCLUDE ..\Makefiles\ms.app

=== BaseTools/Source/C/VfrCompile/Pccts/Makefile ===
#
# Main makefile for PCCTS 1.33MR33	/* MRXXX */
#
pccts:
	pushd . & cd antlr & $(MAKE) /nologo /f AntlrMS.mak & popd
	pushd . & cd dlg & $(MAKE) /nologo /f DlgMS.mak & popd

clean:
	pushd . & cd antlr & $(MAKE) /nologo /f AntlrMS.mak clean & popd
	pushd . & cd dlg & $(MAKE) /nologo /f DlgMS.mak clean & popd

cleanall:
	pushd . & cd antlr & $(MAKE) /nologo /f AntlrMS.mak cleanall & popd
	pushd . & cd dlg & $(MAKE) /nologo /f DlgMS.mak cleanall & popd

=== CryptoPkg/Library/MbedTlsLib/mbedtls/programs/fuzz/Makefile ===
MBEDTLS_TEST_PATH:=../../tests/src
MBEDTLS_TEST_OBJS:=$(patsubst %.c,%.o,$(wildcard ${MBEDTLS_TEST_PATH}/*.c ${MBEDTLS_TEST_PATH}/drivers/*.c))

LOCAL_CFLAGS = -I../../tests/include -I../../include -D_FILE_OFFSET_BITS=64
LOCAL_LDFLAGS = ${MBEDTLS_TEST_OBJS}		\
		-L../../library			\
		-lmbedtls$(SHARED_SUFFIX)	\
		-lmbedx509$(SHARED_SUFFIX)	\
		-lmbedcrypto$(SHARED_SUFFIX)

LOCAL_CFLAGS += $(patsubst -I../%,-I../../%,$(THIRDPARTY_INCLUDES))

ifndef SHARED
DEP=../../library/libmbedcrypto.a ../../library/libmbedx509.a ../../library/libmbedtls.a
else
DEP=../../library/libmbedcrypto.$(DLEXT) ../../library/libmbedx509.$(DLEXT) ../../library/libmbedtls.$(DLEXT)
endif


DLEXT ?= so
EXEXT=
SHARED_SUFFIX=

ifdef FUZZINGENGINE
LOCAL_LDFLAGS += -lFuzzingEngine
endif

# A test application is built for each suites/test_suite_*.data file.
# Application name is same as .data file's base name and can be
# constructed by stripping path 'suites/' and extension .data.
APPS = $(basename $(wildcard fuzz_*.c))

# Construct executable name by adding OS specific suffix $(EXEXT).
BINARIES := $(addsuffix $(EXEXT),$(APPS))

.SILENT:

.PHONY: all check test clean

all: $(BINARIES)

$(DEP):
	$(MAKE) -C ../../library

C_FILES := $(addsuffix .c,$(APPS))

%.o: %.c
	$(CC) $(LOCAL_CFLAGS) $(CFLAGS) -c $<	-o $@


ifdef FUZZINGENGINE
$(BINARIES): %$(EXEXT): %.o common.o $(DEP)
	echo " $(CC) common.o $< $(LOCAL_LDFLAGS) $(LDFLAGS) -o $@"
	$(CXX) common.o $<	$(LOCAL_LDFLAGS) $(LDFLAGS) -o $@
else
$(BINARIES): %$(EXEXT): %.o common.o onefile.o $(DEP)
	echo " $(CC) common.o onefile.o $< $(LOCAL_LDFLAGS) $(LDFLAGS) -o $@"
	$(CC) common.o onefile.o $<	$(LOCAL_LDFLAGS) $(LDFLAGS) -o $@
endif

clean:
ifndef WINDOWS
	rm -rf $(BINARIES) *.o
else
	if exist *.o del /Q /F *.o
	if exist *.exe del /Q /F *.exe
endif

=== CryptoPkg/Library/OpensslLib/openssl/demos/encrypt/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure
# that libcrypto is on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./rsa_encrypt

TESTS = rsa_encrypt

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

rsa_encrypt: rsa_encrypt.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nEncrypt tests:"
	@set -e; for tst in $(TESTS); do \
		echo "\n"$$tst; \
		LD_LIBRARY_PATH=../.. ./$$tst; \
	done

=== MdePkg/Library/MipiSysTLib/mipisyst/library/doxygen/CMakeLists.txt ===

if (SYST_BUILD_DOC)
   if (NOT DOXYGEN_FOUND)
        message(
            WARNING
            "SYST_BUILD_DOC variable set, but Doxygen was not found -skipping documentation"
        )
   else()
         configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../include/mipi_syst.h.in
             ${CMAKE_CURRENT_BINARY_DIR}/gensrc/mipi_syst.h @ONLY
         )
         configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
             ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY
         )
 
         add_custom_target(doc
             ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
             WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
             COMMENT "Generating Doxygen manual for ${CMAKE_PROJECT_NAME} in ${CMAKE_CURRENT_BINARY_DIR}"
             SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${DOXYGEN_IDE_FILES}
           )

         set_target_properties(doc PROPERTIES
             FOLDER "Instrumentation Library"
         )
        endif()
endif(SYST_BUILD_DOC)

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/library/spdm_common_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_library(spdm_common_lib STATIC "")

target_include_directories(spdm_common_lib
    PRIVATE
        ${LIBSPDM_DIR}/include
)

target_sources(spdm_common_lib
    PRIVATE
        libspdm_com_context_data.c
        libspdm_com_context_data_session.c
        libspdm_com_crypto_service.c
        libspdm_com_crypto_service_session.c
        libspdm_com_opaque_data.c
        libspdm_com_support.c
        libspdm_com_msg_log.c
)

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_requester/test_spdm_requester_encap_digests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_requester_encap_digests)

target_include_directories(test_spdm_requester_encap_digests
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_requester/test_spdm_requester_encap_digests
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/os_stub/spdm_device_secret_lib_sample
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include/cmockery
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_requester_encap_digests
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_requester_encap_digests
    PRIVATE
        encap_digests.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_requester_encap_digests
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_requester_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:platform_lib_null>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_sample>
            $<TARGET_OBJECTS:cmockalib>
    )
else()
    target_link_libraries(test_spdm_requester_encap_digests
        PRIVATE
            memlib
            debuglib
            spdm_requester_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            platform_lib_null
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_sample
            cmockalib
    )
endif()

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_requester/test_spdm_requester_encap_key_update/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_requester_encap_key_update)

target_include_directories(test_spdm_requester_encap_key_update
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_requester/test_spdm_requester_encap_key_update
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/os_stub/spdm_device_secret_lib_sample
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include/cmockery
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_requester_encap_key_update
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_requester_encap_key_update
    PRIVATE
        encap_key_update.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_requester_encap_key_update
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_requester_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:platform_lib_null>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_sample>
            $<TARGET_OBJECTS:cmockalib>
    )
else()
    target_link_libraries(test_spdm_requester_encap_key_update
        PRIVATE
            memlib
            debuglib
            spdm_requester_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            platform_lib_null
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_sample
            cmockalib
    )
endif()

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_requester/test_spdm_requester_encap_request/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_requester_encap_request)

target_include_directories(test_spdm_requester_encap_request
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_requester/test_spdm_requester_encap_request
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/os_stub/spdm_device_secret_lib_sample
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include
        ${LIBSPDM_DIR}/unit_test/cmockalib/cmocka/include/cmockery
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_requester_encap_request
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_requester_encap_request
    PRIVATE
        encap_request.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_requester_encap_request
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_requester_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_sample>
            $<TARGET_OBJECTS:cmockalib>
    )
else()
    target_link_libraries(test_spdm_requester_encap_request
        PRIVATE
            memlib
            debuglib
            spdm_requester_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            platform_lib_null
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_sample
            cmockalib
    )
endif()

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_requester/test_spdm_requester_set_key_pair_info/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_requester_set_key_pair_info)

target_include_directories(test_spdm_requester_set_key_pair_info
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_requester/test_spdm_requester_set_key_pair_info
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_requester_set_key_pair_info
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_requester_set_key_pair_info
    PRIVATE
        set_key_pair_info.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_requester_set_key_pair_info
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_requester_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:platform_lib_null>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_null>
    )
else()
    target_link_libraries(test_spdm_requester_set_key_pair_info
        PRIVATE
            memlib
            debuglib
            spdm_requester_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            platform_lib_null
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_null
    )
endif()

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_responder/test_spdm_responder_algorithms/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_responder_algorithms)

target_include_directories(test_spdm_responder_algorithms
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_responder/test_spdm_responder_algorithms
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_responder_algorithms
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_responder_algorithms
    PRIVATE
        algorithms.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_responder_algorithms
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_responder_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_null>
            $<TARGET_OBJECTS:platform_lib_null>
    )
else()
    target_link_libraries(test_spdm_responder_algorithms
        PRIVATE
            memlib
            debuglib
            spdm_responder_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_null
            platform_lib_null
    )
endif()

=== SecurityPkg/DeviceSecurity/SpdmLib/libspdm/unit_test/fuzzing/test_responder/test_spdm_responder_capabilities/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_executable(test_spdm_responder_capabilities)

target_include_directories(test_spdm_responder_capabilities
    PRIVATE
        ${LIBSPDM_DIR}/unit_test/fuzzing/test_responder/test_spdm_responder_capabilities
        ${LIBSPDM_DIR}/include
        ${LIBSPDM_DIR}/unit_test/include
        ${LIBSPDM_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common
        ${LIBSPDM_DIR}/os_stub/include
        ${LIBSPDM_DIR}/os_stub
)

if(TOOLCHAIN STREQUAL "KLEE")
    target_include_directories(test_spdm_responder_capabilities
        PRIVATE
            $ENV{KLEE_SRC_PATH}/include
    )
endif()

target_sources(test_spdm_responder_capabilities
    PRIVATE
        capabilities.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/common.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/toolchain_harness.c
        ${PROJECT_SOURCE_DIR}/unit_test/fuzzing/spdm_unit_fuzzing_common/algo.c
)

if((TOOLCHAIN STREQUAL "KLEE") OR (TOOLCHAIN STREQUAL "CBMC"))
    target_link_libraries(test_spdm_responder_capabilities
        PRIVATE
            $<TARGET_OBJECTS:memlib>
            $<TARGET_OBJECTS:debuglib>
            $<TARGET_OBJECTS:spdm_responder_lib>
            $<TARGET_OBJECTS:spdm_common_lib>
            $<TARGET_OBJECTS:${CRYPTO_LIB_PATHS}>
            $<TARGET_OBJECTS:rnglib>
            $<TARGET_OBJECTS:cryptlib_${CRYPTO}>
            $<TARGET_OBJECTS:malloclib>
            $<TARGET_OBJECTS:spdm_crypt_lib>
            $<TARGET_OBJECTS:spdm_secured_message_lib>
            $<TARGET_OBJECTS:spdm_transport_test_lib>
            $<TARGET_OBJECTS:spdm_device_secret_lib_null>
            $<TARGET_OBJECTS:platform_lib_null>
    )
else()
    target_link_libraries(test_spdm_responder_capabilities
        PRIVATE
            memlib
            debuglib
            spdm_responder_lib
            spdm_common_lib
            ${CRYPTO_LIB_PATHS}
            rnglib
            cryptlib_${CRYPTO}
            malloclib
            spdm_crypt_lib
            spdm_crypt_ext_lib
            spdm_secured_message_lib
            spdm_transport_test_lib
            spdm_device_secret_lib_null
            platform_lib_null
    )
endif()

=== debian/changelog ===
edk2 (2025.02-9) unstable; urgency=medium

  * Cherry-pick openssl fix for timing side-channel in ECDSA signature
    computation, CVE-2024-13176.
    - d/p/0001-Fix-timing-side-channel-in-ECDSA-signature-computati.patch
  * Fix out-of-bounds memory access in NetworkPkg/IScsiDxe, CVE-2024-38805.
    (Closes: #1111100).
    - d/p/0001-NetworkPkg-IScsiDxe-Fix-for-out-of-bound-memory-acce.patch
  * Use virt-firmware to enroll default keys.
  * Initialize the Secure Boot dbx in *.ms.fd with the latest revocations.
    The dbx previously only contained the hash of an empty file.
  * Safe handling of IDT register on SMM entry, CVE-2025-3770.
    (Closes: #1110533).
    - d/p/0001-UefiCpuPkg-PiSmmCpuDxeSmm-Safe-handling-of-IDT-regis.patch
  * Add amdsev image. Thanks to Lukas Märdian. (Closes: #1103961).

 -- dann frazier <dannf@debian.org>  Mon, 01 Sep 2025 14:16:19 -0600

edk2 (2025.02-8) unstable; urgency=medium

  * ovmf, ovmf-ia32, qemu-efi-aarch64: Uninstall the EFI_MEMORY_ATTRIBUTE
    protocol by default in the *.secboot.fd variants to avoid boot crashes
    with incompatible guest operating systems. This is to give virtual
    machine managers like libvirt and incus a release cycle to determine how
    to handle these guests. Add new *.secboot.strictnx.fd variants that users
    can opt-in to to benefit from NX security features. EFI_MEMORY_ATTRIBUTE
    support will be restored for all *.secboot.fd images at the start of
    the next devel cycle, at which point *.secboot.strictnx.fd will become
    symlink aliases. Note this in NEWS.Debian and README.Debian files.
    (Closes: #1103906).
  * Fix out-of-bounds read in HashPeImageByType(), CVE-2024-38797.
    (Closes: #1102519):
    - d/p/0001-SecurityPkg-Out-of-bound-read-in-HashPeImageByType.patch
    - d/p/0002-SecurityPkg-Improving-HashPeImageByType-logic.patch
    - d/p/0003-SecurityPkg-Improving-SecureBootConfigImpl-HashPeIma.patch
    - d/p/0004-SecurityPkg-Update-SecurityFixes.yaml-for-CVE-2024-3.patch

 -- dann frazier <dannf@debian.org>  Mon, 12 May 2025 20:18:11 -0600

edk2 (2025.02-7) unstable; urgency=medium

  * qemu-efi-aarch64: Fix regression with QEMU -kernel (Closes: #1101152):
    - d/p/0001-OvmfPkg-QemuKernelLoaderFsDxe-fix-allocation-failure.patch

 -- dann frazier <dannf@debian.org>  Wed, 16 Apr 2025 08:42:58 -0600

edk2 (2025.02-6) unstable; urgency=medium

  * d/python/UEFI/Qemu.py: Use qemu-system-arm instead of
    qemu-system-aarch64 for testing AAVMF32. I'm not sure why we weren't
    doing this before, but it is required now that QEMU is removing
    64-on-32 support.
  * d/tests/shell.py: Fix DpkgArch initialization.

 -- dann frazier <dannf@debian.org>  Mon, 07 Apr 2025 20:01:37 -0600

edk2 (2025.02-5) unstable; urgency=medium

  * qemu-efi-aarch64: Use PcdUninstallMemAttrProtocol=TRUE instead of
    reverting EFI_MEMORY_ATTRIBUTE protocol support. Drops:
    - d/p/Revert-ArmVirtPkg-make-EFI_LOADER_DATA-non-executabl.patch
    - d/p/ArmVirtPkg-disable-the-EFI_MEMORY_ATTRIBUTE-protocol.patch
  * qemu-efi-aarch64: Only uninstall MemAttrProtocol support in the
    no-secboot image. Users can override this with the QEMU flag:
    -fw_cfg name=opt/org.tianocore/UninstallMemAttrProtocol,string=y
  * ovmf, ovmf32: Add non-upstream patch to add support for
    PcdUninstallMemAttrProtocol and use it to disable the protocol
    on the non-secboot images by default. (Closes: #1099500). Also likely
    addresses LP: #2104316.
  * d/tests/shell.py: Create and use a DpkgArch class to load all of the
    `dpkg-architecture` variables instead of just the host arch.
  * d/tests: Only run tests for 64-bit architectures on 64-bit hosts,
    as QEMU 10 has dropped support for 64-bit architectures on 32-bit hosts.

 -- dann frazier <dannf@debian.org>  Fri, 28 Mar 2025 17:32:23 -0600

edk2 (2025.02-4) unstable; urgency=medium

  * d/tests/shell.py: Add tests to confirm that the built-in shell
    is not available in secboot variants.
  * qemu-efi-aarch64: README.Debian: Correct cut & paste errors that
    reference OVMF images.
  * ovmf: README.Debian: Explain why some images contain a built-in
    shell and others do not.
  * qemu-efi-aarch64: README.Debian: Update to describe the no-secboot
    and secboot images. Warn users that the AAVMF_CODE.fd path is a
    compat symlink that will be removed in the future.
  * Fix remote memory exposure in iSCSI DXE. CVE-2025-2295. (Closes: #1100594)
    - d/p/0001-NetworkPkg-IScsiDxe-Fix-for-Remote-Memory-Exposure-i.patch
  * ovmf, qemu-efi-aarch64: Correct typo in NEWS entry.

 -- dann frazier <dannf@debian.org>  Sun, 23 Mar 2025 12:05:21 -0600

edk2 (2025.02-3) unstable; urgency=medium

  * Return to running Secure Boot tests only for the native architecture
    until #1100819 is fixed.

 -- dann frazier <dannf@debian.org>  Tue, 18 Mar 2025 22:16:33 -0700

edk2 (2025.02-2) unstable; urgency=medium

  * ovmf, qemu-efi-aarch64: Add NEWS to tell users that network boot
    now requires the availability of a random number generator.
    LP: #2069439.
  * qemu-efi-aarch64: Restore the shell in QEMU_EFI.fd. (Closes: #1099424)
    Note: this image is deprecated and will be removed in a future update.
    Please switch to the AAVMF_CODE.* images instead. See README.Debian
    for an overview of these images.
  * ovmf: cherry-pick patch from upstream to "use user-specified
    opt/ovmf/X-PciMmio64Mb value unconditionally". LP: #2101903.
     - d/p/0001-OvmfPkg-Use-user-specified-opt-ovmf-X-PciMmio64Mb-va.patch
    Thanks to Mitchell Augustin.
  * d/tests: autopkgtest doesn't seem to support foreign arch deps in
    d/tests/control when doing native testing. Manually install signed
    grub and shim packages for amd64 and arm64 for Secure Boot tests.

 -- dann frazier <dannf@debian.org>  Sat, 15 Mar 2025 15:16:39 -0600

edk2 (2025.02-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202502 tag:
    - Drop patches merged upstream:


=== debian/control ===
Source: edk2
Section: misc
Priority: optional
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: dann frazier <dannf@debian.org>
Build-Depends: bc,
 debhelper-compat (= 12),
 dh-exec,
 dosfstools,
 dpkg (>= 1.19.3),
 gcc-aarch64-linux-gnu,
 gcc-arm-linux-gnueabi,
 gcc-multilib [i386],
 gcc-riscv64-linux-gnu,
 gcc-loongarch64-linux-gnu,
 iasl,
 lsb-release,
 mtools,
 nasm,
 python3,
 python3-virt-firmware,
 qemu-utils,
 qemu-system-arm (>= 1:2.12+dfsg),
 qemu-system-x86 (>= 1:2.12+dfsg),
 uuid-dev,
 xorriso,
Standards-Version: 4.5.0
Homepage: http://www.tianocore.org
Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
XS-Build-Indep-Architecture: amd64

Package: ovmf
Architecture: all
Depends: ${misc:Depends}
Replaces: qemu-system-common (<<1.7.0+dfsg-3ubuntu4)
Suggests: qemu-system-x86
Multi-Arch: foreign
Description: UEFI firmware for 64-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.

Package: ovmf-ia32
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-x86
Multi-Arch: foreign
Description: UEFI firmware for 32-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 32-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.

Package: qemu-efi-arm
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-arm
Multi-Arch: foreign
Description: UEFI firmware for 32-bit ARM virtual machines
 qemu-efi-arm is a build of EDK II for 32-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi-aarch64
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu-efi (<< 0~20161202.7bbe0b3e-2)
Suggests: qemu-system-arm
Multi-Arch: foreign
Description: UEFI firmware for 64-bit ARM virtual machines
 qemu-efi-aarch64 is a build of EDK II for 64-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi-riscv64
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-riscv64
Multi-Arch: foreign
Description: UEFI firmware for RISCV64 virtual machines
 qemu-efi-riscv64 is a build of EDK II for RISCV64 virtual machines.

Package: qemu-efi-loongarch64
Architecture: all
Depends: ${misc:Depends}
Suggests: qemu-system-misc
Multi-Arch: foreign
Description: UEFI firmware for LoongArch64 virtual machines
 qemu-efi-loongarch64 is a build of EDK II for LoongArch64 virtual machines.

Package: efi-shell-ia32
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 32-bit x86 architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellia32.efi binary for the a 32-bit x86
 architecture.

Package: efi-shell-x64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit x86 architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellx64.efi binary for the 64-bit x86
 architecture.

Package: efi-shell-arm
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 32-bit ARM architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellarm.efi binary for the 32-bit ARM
 architecture.

Package: efi-shell-aa64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit ARM architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellaa64.efi binary for the 64-bit ARM
 architecture.

Package: efi-shell-riscv64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit RISC-V architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellriscv64.efi binary for the 64-bit RISC-V
 architecture.

Package: efi-shell-loongarch64
Architecture: all
Depends: ${misc:Depends}
Description: UEFI Shell for 64-bit LoongArch architecture
 The UEFI Shell provides a command line interface running on top of the EFI API.
 It can be used to execute EFI binaries, to manage EFI variables and boot
 options, or to display details of installed devices, drivers, and protocols.
 This package contains the shellloongarch64.efi binary for the 64-bit LoongArch
 architecture.

=== debian/rules ===
#!/usr/bin/make -f

SHELL=/bin/bash

include /usr/share/dpkg/default.mk

# Set to DEBUG for debug builds
BUILD_TYPE ?= RELEASE
EDK2_TOOLCHAIN = GCC5
export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabi-
export $(EDK2_TOOLCHAIN)_RISCV64_PREFIX=riscv64-linux-gnu-
export $(EDK2_TOOLCHAIN)_LOONGARCH64_PREFIX=loongarch64-linux-gnu-

export PYTHON3_ENABLE=TRUE

ifeq ($(DEB_BUILD_ARCH),amd64)
	EDK2_BUILD_ARCH=X64
endif
ifeq ($(DEB_BUILD_ARCH),i386)
	EDK2_BUILD_ARCH=IA32
endif
ifeq ($(DEB_BUILD_ARCH),arm64)
	EDK2_BUILD_ARCH=AARCH64
endif

# LP: #2078252
unexport ELF_PACKAGE_METADATA

PCD_RELEASE_DATE = $(shell date -d@$(SOURCE_DATE_EPOCH) "+%m/%d/%Y")
PCD_FLAGS  = --pcd PcdFirmwareVendor=L"$(shell lsb_release -is) distribution of EDK II\\0"
PCD_FLAGS += --pcd PcdFirmwareVersionString=L"$(DEB_VERSION)\\0"
PCD_FLAGS += --pcd PcdFirmwareReleaseDateString=L"$(PCD_RELEASE_DATE)\\0"
COMMON_FLAGS  = -DCC_MEASUREMENT_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_HTTP_BOOT_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_IP6_ENABLE=TRUE
COMMON_FLAGS += -DNETWORK_TLS_ENABLE
COMMON_FLAGS += $(PCD_FLAGS)

NO_STRICTNX_COMMON_FLAGS = --pcd PcdUninstallMemAttrProtocol=TRUE

OVMF_COMMON_FLAGS  = $(COMMON_FLAGS)
OVMF_COMMON_FLAGS += -DTPM2_ENABLE=TRUE
# Uncomment for in-band debug messages
# OVMF_COMMON_FLAGS += "-DDEBUG_ON_SERIAL_PORT=TRUE"
OVMF_4M_COMMON_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
OVMF_4M_NO_SECBOOT_FLAGS = $(OVMF_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
OVMF_4M_SECBOOT_FLAGS = $(OVMF_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF_4M_SECBOOT_STRICTNX_FLAGS = $(OVMF_4M_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF32_4M_COMMON_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
OVMF32_4M_NO_SECBOOT_FLAGS = $(OVMF32_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
OVMF32_4M_SECBOOT_FLAGS = $(OVMF32_4M_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE
OVMF32_4M_SECBOOT_STRICTNX_FLAGS = $(OVMF32_4M_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE -DSMM_REQUIRE=TRUE

AAVMF_COMMON_FLAGS  = $(COMMON_FLAGS)
AAVMF_COMMON_FLAGS += -DTPM2_ENABLE=TRUE
AAVMF_COMMON_FLAGS += -DTPM2_CONFIG_ENABLE=TRUE
AAVMF_COMMON_FLAGS += -DCAVIUM_ERRATUM_27456=TRUE
AAVMF_NO_SECBOOT_FLAGS = $(COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS)
AAVMF_SECBOOT_FLAGS = $(AAVMF_COMMON_FLAGS) $(NO_STRICTNX_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE
AAVMF_SECBOOT_STRICTNX_FLAGS = $(AAVMF_COMMON_FLAGS) -DBUILD_SHELL=FALSE -DSECURE_BOOT_ENABLE=TRUE

RISCV64_FLAGS = $(COMMON_FLAGS)
LOONGARCH64_FLAGS = $(COMMON_FLAGS)

# Clear variables used internally by the edk2 build system
undefine WORKSPACE
undefine ECP_SOURCE
undefine EDK_SOURCE
undefine EFI_SOURCE
undefine EDK_TOOLS_PATH
undefine CONF_PATH

%:
	dh $@

override_dh_auto_build: build-qemu-efi-aarch64 build-qemu-efi-arm build-ovmf build-ovmf32 build-qemu-efi-riscv64 build-qemu-efi-loongarch64

debian/setup-build-stamp:
	set -e; . ./edksetup.sh; \
	make -C BaseTools ARCH=$(EDK2_BUILD_ARCH)
	touch $@

OVMF_INSTALL_DIR = debian/ovmf-install
OVMF64_BUILD_ROOT = Build/OvmfX64
OVMF64_BUILD_DIR = $(OVMF64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
AMDSEV_BUILD_ROOT = Build/AmdSev
AMDSEV_BUILD_DIR = $(AMDSEV_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
OVMF_ENROLL = $(OVMF_INSTALL_DIR)/EnrollDefaultKeys.efi
OVMF_SHELL =  $(OVMF_INSTALL_DIR)/Shell.efi
OVMF_BINARIES = $(OVMF_ENROLL) $(OVMF_SHELL)
OVMF_IMAGES := $(addprefix $(OVMF_INSTALL_DIR)/,OVMF_CODE_4M.fd OVMF_CODE_4M.secboot.fd OVMF_CODE_4M.secboot.strictnx.fd OVMF_VARS_4M.fd OVMF.amdsev.fd)
OVMF_PREENROLLED_VARS := $(addprefix $(OVMF_INSTALL_DIR)/,OVMF_VARS_4M.ms.fd OVMF_VARS_4M.snakeoil.fd)

OVMF32_INSTALL_DIR = debian/ovmf32-install
OVMF32_BUILD_ROOT = Build/OvmfIa32
OVMF32_BUILD_DIR = $(OVMF32_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
OVMF32_SHELL = $(OVMF32_BUILD_DIR)/IA32/Shell.efi
OVMF32_BINARIES = $(OVMF32_SHELL)
OVMF32_IMAGES  := $(addprefix $(OVMF32_INSTALL_DIR)/,OVMF32_CODE_4M.fd OVMF32_CODE_4M.secboot.fd OVMF32_CODE_4M.secboot.strictnx.fd OVMF32_VARS_4M.fd)

AAVMF_INSTALL_DIR = debian/aavmf-install
AAVMF_BUILD_ROOT = Build/ArmVirtQemu-AARCH64
AAVMF_BUILD_DIR = $(AAVMF_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
AAVMF_ENROLL    = $(AAVMF_INSTALL_DIR)/EnrollDefaultKeys.efi
AAVMF_SHELL     = $(AAVMF_INSTALL_DIR)/Shell.efi
AAVMF_BINARIES  = $(AAVMF_ENROLL) $(AAVMF_SHELL)
AAVMF_IMAGES    = $(addprefix $(AAVMF_INSTALL_DIR)/,AAVMF_CODE.no-secboot.fd AAVMF_CODE.secboot.fd AAVMF_CODE.secboot.strictnx.fd AAVMF_VARS.fd)
AAVMF_PREENROLLED_VARS = $(addprefix $(AAVMF_INSTALL_DIR)/,AAVMF_VARS.ms.fd AAVMF_VARS.snakeoil.fd)

AAVMF32_INSTALL_DIR = debian/aavmf32-install
AAVMF32_BUILD_ROOT = Build/ArmVirtQemu-ARM
AAVMF32_BUILD_DIR = $(AAVMF32_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
AAVMF32_IMAGES    = $(addprefix $(AAVMF32_INSTALL_DIR)/,AAVMF32_CODE.fd AAVMF32_VARS.fd)

RISCV64_INSTALL_DIR = debian/riscv64-install
RISCV64_BUILD_ROOT = Build/RiscVVirtQemu
RISCV64_BUILD_DIR = $(RISCV64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
RISCV64_IMAGES    = $(addprefix $(RISCV64_INSTALL_DIR)/,RISCV_VIRT_CODE.fd RISCV_VIRT_VARS.fd)

LOONGARCH64_INSTALL_DIR = debian/loongarch64-install
LOONGARCH64_BUILD_ROOT = Build/LoongArchVirtQemu
LOONGARCH64_BUILD_DIR = $(LOONGARCH64_BUILD_ROOT)/$(BUILD_TYPE)_$(EDK2_TOOLCHAIN)
LOONGARCH64_IMAGES    = $(addprefix $(LOONGARCH64_INSTALL_DIR)/,QEMU_EFI.fd QEMU_VARS.fd)

build-ovmf32: $(OVMF32_BINARIES) $(OVMF32_IMAGES)
$(OVMF32_BINARIES) $(OVMF32_IMAGES): debian/setup-build-stamp
	rm -rf $(OVMF32_INSTALL_DIR)
	mkdir $(OVMF32_INSTALL_DIR)
	set -e; . ./edksetup.sh; \
		build -a IA32 \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgIa32.dsc \
			$(OVMF32_4M_NO_SECBOOT_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF32_BUILD_DIR)/IA32/Shell.efi \
		$(OVMF32_INSTALL_DIR)/
	cp $(OVMF32_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF32_INSTALL_DIR)/OVMF32_CODE_4M.fd
	cp $(OVMF32_BUILD_DIR)/FV/OVMF_VARS.fd \
		$(OVMF32_INSTALL_DIR)/OVMF32_VARS_4M.fd
	rm -rf $(OVMF32_BUILD_ROOT)
	set -e; . ./edksetup.sh; \
	build -a IA32 \
		-t $(EDK2_TOOLCHAIN) \
		-p OvmfPkg/OvmfPkgIa32.dsc \
		$(OVMF32_4M_SECBOOT_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF32_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF32_INSTALL_DIR)/OVMF32_CODE_4M.secboot.fd
	rm -rf $(OVMF32_BUILD_ROOT)
	set -e; . ./edksetup.sh; \
	build -a IA32 \
		-t $(EDK2_TOOLCHAIN) \
		-p OvmfPkg/OvmfPkgIa32.dsc \
		$(OVMF32_4M_SECBOOT_STRICTNX_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF32_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF32_INSTALL_DIR)/OVMF32_CODE_4M.secboot.strictnx.fd

build-ovmf: $(OVMF_BINARIES) $(OVMF_IMAGES) $(OVMF_PREENROLLED_VARS)
$(OVMF_BINARIES) $(OVMF_IMAGES): debian/setup-build-stamp
	rm -rf $(OVMF_INSTALL_DIR)
	mkdir $(OVMF_INSTALL_DIR)
	rm -rf $(OVMF64_BUILD_ROOT)
	set -e; . ./edksetup.sh; \
		build -a X64 \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_4M_NO_SECBOOT_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF64_BUILD_DIR)/X64/Shell.efi \
		$(OVMF_INSTALL_DIR)/
	cp $(OVMF64_BUILD_DIR)/FV/OVMF.fd $(OVMF_INSTALL_DIR)/
	cp $(OVMF64_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF_INSTALL_DIR)/OVMF_CODE_4M.fd
	cp $(OVMF64_BUILD_DIR)/FV/OVMF_VARS.fd \
		$(OVMF_INSTALL_DIR)/OVMF_VARS_4M.fd
	rm -rf $(OVMF64_BUILD_ROOT)
	set -e; . ./edksetup.sh; \
		build -a X64 \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_4M_SECBOOT_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF64_BUILD_DIR)/X64/EnrollDefaultKeys.efi \
		$(OVMF_INSTALL_DIR)/
	cp $(OVMF64_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF_INSTALL_DIR)/OVMF_CODE_4M.secboot.fd
	rm -rf $(OVMF64_BUILD_ROOT)
	set -e; . ./edksetup.sh; \
		build -a X64 \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_4M_SECBOOT_STRICTNX_FLAGS) -b $(BUILD_TYPE)
	cp $(OVMF64_BUILD_DIR)/X64/EnrollDefaultKeys.efi \
		$(OVMF_INSTALL_DIR)/
	cp $(OVMF64_BUILD_DIR)/FV/OVMF_CODE.fd \
		$(OVMF_INSTALL_DIR)/OVMF_CODE_4M.secboot.strictnx.fd

=== debian/watch ===
# Currently only useful for checking for a new release. There's additional
# upstream tarball mangling required via ./debian/rules get-orig-source.
# Also - doesn't check for new qemu-ovmf-secureboot releases.
version=4
opts="filenamemangle=s/.+\/edk2-stable(\d{6})\.tar\.gz/edk2-0.0~$1.tar.gz/, \
      uversionmangle=s/(\d{6})/0.0~$1/" \
     https://github.com/tianocore/edk2/tags \
     .*/edk2-stable(\d{6})\.tar\.gz debian uupdate
